## glvis 4.3

=== CMakeLists.txt ===
# Copyright (c) 2010-2024, Lawrence Livermore National Security, LLC. Produced
# at the Lawrence Livermore National Laboratory. All Rights reserved. See files
# LICENSE and NOTICE for details. LLNL-CODE-443271.
#
# This file is part of the GLVis visualization tool and library. For more
# information and source code availability see https://glvis.org.
#
# GLVis is free software; you can redistribute it and/or modify it under the
# terms of the BSD-3 license. We welcome feedback and contributions, see file
# CONTRIBUTING.md for details.

# CMake v3.10 is where "Imported Targets" like "Freetype::Freetype" are
# introduced.
cmake_minimum_required(VERSION 3.10)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Prohibit in-source builds
if ("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  message(FATAL_ERROR "In-source builds are prohibited.")
endif ("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")

project(glvis NONE)

# Import MFEM. The following variables can be used to help CMake find MFEM:
#  * MFEM_DIR - absolute path to the MFEM build or install prefix.
#  * mfem_DIR - absolute path to where MFEMConfig.cmake is.
message(STATUS "Looking for mfem ...")
set(MFEM_DIR "" CACHE PATH "Path to the MFEM build or install prefix.")
if (MFEM_DIR)
   find_package(mfem REQUIRED NAMES MFEM HINTS "${MFEM_DIR}"
                "${MFEM_DIR}/lib/cmake/mfem" NO_DEFAULT_PATH)
else()
   find_package(mfem REQUIRED NAMES MFEM)
endif()
message(STATUS "Found mfem config in: ${mfem_DIR} (version ${MFEM_VERSION})")
# Use the same C++ compiler as MFEM. This is needed when MFEM was built using
# an MPI wrapper and we do not have explicitly the MPI compile and link flags.
if (NOT CMAKE_CXX_COMPILER AND MFEM_CXX_COMPILER)
  set(CMAKE_CXX_COMPILER "${MFEM_CXX_COMPILER}")
endif()

enable_language(C)
enable_language(CXX)

# Default options match the Makefile
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()

option(GLVIS_USE_LIBTIFF
  "Use libtiff for taking screenshots internally"
  OFF)

option(GLVIS_USE_LIBPNG
  "Use libpng for taking screenshots internally"
  ON)

#
# Handle a few other definitions
#

# Default multisampling mode
if (NOT GLVIS_MULTISAMPLE)
  set(GLVIS_MULTISAMPLE 4)
endif (NOT GLVIS_MULTISAMPLE)

# Default multisampling line-width
if (NOT GLVIS_MS_LINEWIDTH)
  if (NOT APPLE)
    set(GLVIS_MS_LINEWIDTH 1.4)
  else()
    # This value seems to work better on Macs
    set(GLVIS_MS_LINEWIDTH 1.0)
  endif()
endif (NOT GLVIS_MS_LINEWIDTH)

# Default font size
if (NOT GLVIS_FONT_SIZE)
  set(GLVIS_FONT_SIZE 12)
endif (NOT GLVIS_FONT_SIZE)

#
# Start finding everything
#

set(_glvis_compile_defs)
set(_glvis_compile_opts)
set(_glvis_include_dirs)
set(_glvis_libraries)

list(APPEND _glvis_compile_defs "GLVIS_MULTISAMPLE=${GLVIS_MULTISAMPLE}")
list(APPEND _glvis_compile_defs "GLVIS_MS_LINEWIDTH=${GLVIS_MS_LINEWIDTH}")
list(APPEND _glvis_compile_defs "GLVIS_FONT_SIZE=${GLVIS_FONT_SIZE}")
if (NOT WIN32)
  list(APPEND _glvis_compile_defs "GLVIS_USE_LOGO")
else()
  list(APPEND _glvis_compile_defs "_USE_MATH_DEFINES")
endif()

if(NOT WIN32)
  find_program(XXD_FOUND xxd)
  if(NOT XXD_FOUND)
    message(FATAL_ERROR "Required tool not found: xxd.")
  endif()
endif()

if (CMAKE_BUILD_TYPE MATCHES "Debug|debug|DEBUG")
  list(APPEND _glvis_compile_defs "GLVIS_DEBUG")
  list(APPEND _glvis_compile_opts "-Wall")
endif()

# Include paths and libraries needed by MFEM
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${MFEM_CXX_FLAGS}")
list(APPEND _glvis_include_dirs "${MFEM_INCLUDE_DIRS}")
list(APPEND _glvis_libraries "${MFEM_LIBRARIES}")

if (NOT EMSCRIPTEN)

  # Find OpenGL
  find_package(OpenGL REQUIRED)
  list(APPEND _glvis_libraries OpenGL::GL)

  # Find 'SDL2' which is not part of the CMake standard modules
  list(APPEND SDL2_DIR "../SDL2")
  set(SDL2_DIR_SAVE ${SDL2_DIR})
  find_package(SDL2 QUIET HINTS ${SDL2_DIR})
  # The SDL2 target 'SDL2::SDL2' is not always defined, so instead we use
  # directly 'SDL2_INCLUDE_DIRS' and 'SDL2_LIBRARIES'.
  if (TARGET SDL2::SDL2)
    list(APPEND _glvis_libraries SDL2::SDL2)
  elseif (SDL2_INCLUDE_DIRS AND SDL2_LIBRARIES)
    # SDL2_INCLUDE_DIRS is defined with 'SDL2' at the end of the path we need to
    # strip that.
    set(new_list_)
    foreach (path IN LISTS SDL2_INCLUDE_DIRS)
      string(REGEX REPLACE "/include/SDL2$" "/include" new_path_ "${path}")
      list(APPEND new_list_ "${new_path_}")
    endforeach()
    set(SDL2_INCLUDE_DIRS ${new_list_})
    list(APPEND _glvis_include_dirs "${SDL2_INCLUDE_DIRS}")
    list(APPEND _glvis_libraries "${SDL2_LIBRARIES}")
  else()
    # find_package() did not work; try more direct approach.
    set(SDL2_DIR ${SDL2_DIR_SAVE})
    find_path(SDL2_INCLUDE_DIRS "SDL2/SDL.h"
      HINTS ${SDL2_DIR} ENV SDL2_DIR
      PATH_SUFFIXES "include"
      DOC "SDL2 include path.")
    find_library(SDL2_LIBRARIES "SDL2"
      HINTS ${SDL2_DIR} ENV SDL2_DIR
      PATH_SUFFIXES "lib"
      DOC "SDL2 library.")
    if (NOT (SDL2_INCLUDE_DIRS AND SDL2_LIBRARIES))
      message(FATAL_ERROR "SDL2 library not found. Please set SDL2_DIR.")
    endif()
    list(APPEND _glvis_include_dirs "${SDL2_INCLUDE_DIRS}")
    list(APPEND _glvis_libraries "${SDL2_LIBRARIES}")
  endif()
  message(STATUS "SDL2 found: ${SDL2_LIBRARIES}")
  message(STATUS "SDL2_INCLUDE_DIRS = ${SDL2_INCLUDE_DIRS}")

  # Find GLEW
  # GLEW search path can be set using CMAKE_PREFIX_PATH
  list(APPEND CMAKE_PREFIX_PATH "../glew")
  find_package(GLEW REQUIRED)
  list(APPEND _glvis_libraries GLEW::GLEW)

  # Find 'glm' which is not part of the CMake standard modules
  list(APPEND GLM_DIR "../glm")
  find_package(glm QUIET HINTS ${GLM_DIR})
  if (NOT GLM_INCLUDE_DIRS)
    find_path(GLM_INCLUDE_DIRS "glm/glm.hpp"
      HINTS ${GLM_DIR} ENV GLM_DIR
      PATH_SUFFIXES "include"
      DOC "GLM include path.")
    if (NOT GLM_INCLUDE_DIRS)
      message(FATAL_ERROR "GLM headers not found. Please set GLM_DIR.")
    endif()
  endif()
  message(STATUS "GLM headers found: ${GLM_INCLUDE_DIRS}")
  list(APPEND _glvis_include_dirs "${GLM_INCLUDE_DIRS}")

  # Find TIFF
  if (GLVIS_USE_LIBTIFF)
    find_package(TIFF)
    if (TIFF_FOUND)
      list(APPEND _glvis_compile_defs "GLVIS_USE_LIBTIFF")
      list(APPEND _glvis_libraries TIFF::TIFF)
    else()
      message(WARNING "TIFF library not found. TIFF disabled.")
      set(GLVIS_USE_LIBTIFF OFF)
    endif (TIFF_FOUND)
  endif (GLVIS_USE_LIBTIFF)

  # Find PNG
  if (GLVIS_USE_LIBPNG)
    find_package(PNG)
    if (PNG_FOUND)
      list(APPEND _glvis_compile_defs "GLVIS_USE_LIBPNG")
      list(APPEND _glvis_libraries PNG::PNG)
    else()
      message(WARNING "PNG library not found. PNG disabled.")
      set(GLVIS_USE_LIBPNG OFF)
    endif (PNG_FOUND)
  endif (GLVIS_USE_LIBPNG)

  # Find FreeType.
  find_package(Freetype REQUIRED)
  # Find FontConfig (FindFontconfig.cmake was added in CMake 3.14)
  find_library(FONTCONFIG_LIBRARY fontconfig
    HINTS ${FONTCONFIG_DIR} $ENV{FONTCONFIG_DIR}
    DOC "The fontconfig library for use with FreeType."
    NO_DEFAULT_PATH)
  find_library(FONTCONFIG_LIBRARY fontconfig)
  if (FONTCONFIG_LIBRARY)
    list(APPEND _glvis_libraries Freetype::Freetype)
    # Need FONTCONFIG_INCLUDE_DIRS?
    list(APPEND _glvis_libraries "${FONTCONFIG_LIBRARY}")
    message(STATUS "Found Fontconfig: ${FONTCONFIG_LIBRARY}")
  else()
    message(STATUS "Fontconfig not found. Please set FONTCONFIG_DIR.")
    message(FATAL_ERROR "Fontconfig not found.")
  endif (FONTCONFIG_LIBRARY)

  # Find threading library
  find_package(Threads REQUIRED)
  list(APPEND _glvis_libraries "${CMAKE_THREAD_LIBS_INIT}")
  if (CMAKE_USE_PTHREADS_INIT)
    message(STATUS "System threading library: pthreads")
  elseif (CMAKE_USE_WIN32_THREADS_INIT)
    message(STATUS "System threading library: Win32 threads")
  elseif (Threads_FOUND)
    message(STATUS "System threading library: other")
  endif()

else(NOT EMSCRIPTEN)

  find_package(glm REQUIRED)
  list(APPEND _glvis_include_dirs "${GLM_INCLUDE_DIRS}")
  set(_emscripten_opts)
  # Enable embind
  list(APPEND _emscripten_opts "--bind")

  # OpenGL, SDL2, and GLEW are provided by the Emscripten runtime
  # Enable SDL2
  list(APPEND _emscripten_opts "-s USE_SDL=2")
  list(APPEND _emscripten_opts
      "-s DISABLE_DEPRECATED_FIND_EVENT_TARGET_BEHAVIOR=0")

  # Set WebGL options
  list(APPEND _emscripten_opts
      "-s GL_ASSERTIONS=1 -s GL_DEBUG=1 -s MAX_WEBGL_VERSION=2")

  # Enable Freetype port
  list(APPEND _emscripten_opts "-s USE_FREETYPE=1")

  # Module export options
  list(APPEND _emscripten_opts "-s ENVIRONMENT=web")
  list(APPEND _emscripten_opts "-s MODULARIZE=1")
  list(APPEND _emscripten_opts "-s EXPORT_NAME=glvis")

  # Other emscripten options
  list(APPEND _emscripten_opts "-s ALLOW_MEMORY_GROWTH=1")
  list(APPEND _emscripten_opts "-s SINGLE_FILE=1")
  list(APPEND _emscripten_opts "--no-heap-copy")

  # Since we don't have access to fontconfig, embed a font
  if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/OpenSans.ttf")
    message(FATAL_ERROR "Preload font file \"OpenSans.ttf\" not found.")
  endif()
  list(APPEND _emscripten_opts
       "--embed-file ${CMAKE_CURRENT_SOURCE_DIR}/OpenSans.ttf@OpenSans.ttf")

endif(NOT EMSCRIPTEN)

message(STATUS "GLVis build type: CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")
message(STATUS "GLVis defines: ${_glvis_compile_defs}")
# message(STATUS "GLVis opts: ${_glvis_compile_opts}")
# message(STATUS "GLVis include dirs: ${_glvis_include_dirs}")
# message(STATUS "GLVis libraries: ${_glvis_libraries}")
message(STATUS "CMAKE_INSTALL_PREFIX = ${CMAKE_INSTALL_PREFIX}")


#
# Setup the GLVis library target
#

add_subdirectory(lib)
add_subdirectory(share)

if(NOT EMSCRIPTEN)

  # Setup the GLVis executable
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH ON CACHE BOOL "")
  set(CMAKE_INSTALL_RPATH "${MFEM_LIBRARY_DIR}" CACHE PATH "")

  add_executable(glvis-exe glvis.cpp)
  set_target_properties(glvis-exe PROPERTIES OUTPUT_NAME glvis)

  target_link_libraries(glvis-exe PRIVATE glvis)

  if (WIN32)
    target_sources(glvis-exe
      PRIVATE
        "share/windows.manifest"
        "${CMAKE_CURRENT_BINARY_DIR}/share/resource.rc")
  else()
    target_link_libraries(glvis-exe PRIVATE glvis_logo)
  endif (WIN32)

  # Install the executable
  install(TARGETS glvis-exe RUNTIME DESTINATION bin)

  # Install the gnutls helper script
  if (MFEM_USE_GNUTLS)
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/glvis-keygen.sh
      DESTINATION bin
      PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
        GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
  endif (MFEM_USE_GNUTLS)

  if (APPLE)
    set(GLVIS_APP_ICON ${CMAKE_CURRENT_SOURCE_DIR}/share/GLVis.icns)
    set(GLVIS_APP_CREDITS ${CMAKE_CURRENT_SOURCE_DIR}/share/Credits.rtf)
    set_source_files_properties(
      ${GLVIS_APP_ICON} ${GLVIS_APP_CREDITS}
      PROPERTIES
        MACOSX_PACKAGE_LOCATION "Resources")

    add_executable(app MACOSX_BUNDLE glvis.cpp
      ${GLVIS_APP_ICON} ${GLVIS_APP_CREDITS})
    set_target_properties(app
      PROPERTIES
        EXCLUDE_FROM_ALL TRUE
        OUTPUT_NAME GLVis
        MACOSX_BUNDLE_INFO_PLIST
          ${CMAKE_CURRENT_SOURCE_DIR}/share/Info.cmake.plist.in)
    target_link_libraries(app PRIVATE glvis glvis_logo)
    install(TARGETS app
      RUNTIME DESTINATION .
      BUNDLE DESTINATION .)
    install(CODE [[
      include (BundleUtilities)
      fixup_bundle("${CMAKE_INSTALL_PREFIX}/GLVis.app" "" "")
    ]] COMPONENT RUNTIME)
  endif(APPLE)

endif(NOT EMSCRIPTEN)

if(ENABLE_TESTS)
  enable_testing()
  add_subdirectory(tests)
endif(ENABLE_TESTS)

=== lib/CMakeLists.txt ===
# Copyright (c) 2010-2024, Lawrence Livermore National Security, LLC. Produced
# at the Lawrence Livermore National Laboratory. All Rights reserved. See files
# LICENSE and NOTICE for details. LLNL-CODE-443271.
#
# This file is part of the GLVis visualization tool and library. For more
# information and source code availability see https://glvis.org.
#
# GLVis is free software; you can redistribute it and/or modify it under the
# terms of the BSD-3 license. We welcome feedback and contributions, see file
# CONTRIBUTING.md for details.

list(APPEND SOURCES
  gl/renderer.cpp
  gl/renderer_core.cpp
  gl/shader.cpp
  gl/types.cpp
  aux_vis.cpp
  font.cpp
  gltf.cpp
  material.cpp
  openglvis.cpp
  palettes.cpp
  sdl.cpp
  sdl_helper.cpp
  sdl_main.cpp
  stream_reader.cpp
  vsdata.cpp
  vssolution.cpp
  vssolution3d.cpp
  vsvector.cpp
  vsvector3d.cpp)

list(APPEND HEADERS
  gl/attr_traits.hpp
  gl/platform_gl.hpp
  gl/renderer.hpp
  gl/renderer_core.hpp
  gl/shader.hpp
  gl/types.hpp
  aux_vis.hpp
  font.hpp
  geom_utils.hpp
  gltf.hpp
  logo.hpp
  material.hpp
  openglvis.hpp
  palettes.hpp
  sdl.hpp
  sdl_helper.hpp
  sdl_main.hpp
  sdl_mac.hpp
  stream_reader.hpp
  visual.hpp
  vsdata.hpp
  vssolution.hpp
  vssolution3d.hpp
  vsvector.hpp
  vsvector3d.hpp)

if(EMSCRIPTEN)
  # Emscripten build target
  list(APPEND SOURCES aux_js.cpp)
  add_executable(libglvis ${SOURCES} ${HEADERS})

  # Copy font to lib folder
  configure_file(../OpenSans.ttf OpenSans.ttf COPYONLY)

  # Set Emscripten options first, since "-s" emscripten options can't be passed
  # through target_compile_options/target_link_libraries
  string(REPLACE ";" " " _emscripten_opts "${_emscripten_opts}")
  set_target_properties(libglvis PROPERTIES COMPILE_FLAGS "${_emscripten_opts}")
  set_target_properties(libglvis PROPERTIES LINK_FLAGS "${_emscripten_opts}")

  target_compile_definitions(libglvis PUBLIC ${_glvis_compile_defs})
  target_include_directories(libglvis SYSTEM PUBLIC "${_glvis_include_dirs}")
  target_link_libraries(libglvis PUBLIC "${_glvis_libraries}")
else()
  # Desktop build target
  list(APPEND SOURCES gl/renderer_ff.cpp threads.cpp gl2ps.c sdl_x11.cpp)
  list(APPEND HEADERS gl/renderer_ff.hpp threads.hpp gl2ps.h sdl_x11.hpp)
  if (APPLE)
    list(APPEND SOURCES sdl_mac.mm)
    list(APPEND HEADERS sdl_mac.hpp)
  endif()
  if (WIN32)
    list(APPEND SOURCES sdl_windows.cpp)
    list(APPEND HEADERS sdl_windows.hpp)
  endif()
  add_library(glvis ${SOURCES} ${HEADERS})
  target_compile_definitions(glvis PUBLIC "${_glvis_compile_defs}")
  target_compile_options(glvis PUBLIC "${_glvis_compile_opts}")
  target_include_directories(glvis SYSTEM PUBLIC "${_glvis_include_dirs}")
  target_link_libraries(glvis PUBLIC "${_glvis_libraries}")
  if (APPLE)
    target_link_libraries(glvis PUBLIC "-framework Cocoa")
  endif()
endif(EMSCRIPTEN)

=== tests/CMakeLists.txt ===
# Copyright (c) 2010-2024, Lawrence Livermore National Security, LLC. Produced
# at the Lawrence Livermore National Laboratory. All Rights reserved. See files
# LICENSE and NOTICE for details. LLNL-CODE-443271.
#
# This file is part of the GLVis visualization tool and library. For more
# information and source code availability see https://glvis.org.
#
# GLVis is free software; you can redistribute it and/or modify it under the
# terms of the BSD-3 license. We welcome feedback and contributions, see file
# CONTRIBUTING.md for details.

if(NOT EMSCRIPTEN)

# Used for automated testing
set(GLVIS_BASELINE_SYS local CACHE STRING
    "The location to use for testing baselines.")

add_custom_target(
  glvis-test-driver ALL
  COMMAND ${CMAKE_COMMAND} -E copy
    ${CMAKE_CURRENT_SOURCE_DIR}/glvis_driver.py
    ${CMAKE_CURRENT_BINARY_DIR}/glvis_driver.py
  DEPENDS glvis_driver.py
  COMMENT "Copying glvis_driver.py")

set(stream_tests
    "capacitor"
    "distance"
    "ex1"
    "ex2"
    "ex27"
    "ex3"
    "ex5"
    "ex9"
    "klein-bottle"
    "laghos"
    "mesh-explorer"
    "mfem-logo"
    "minimal-surface"
    "mobius-strip"
    "navier"
    "quad"
    "quadrature-lor"
    "remhos"
    "shaper"
    "shifted"
    "snake")

add_custom_target(rebaseline)

foreach(test_name IN LISTS stream_tests)

  add_test(NAME stream_${test_name}
           COMMAND python3 ${CMAKE_CURRENT_BINARY_DIR}/glvis_driver.py
           -e ${CMAKE_CURRENT_BINARY_DIR}/../glvis
           -s ${CMAKE_CURRENT_SOURCE_DIR}/data/streams/${test_name}.saved
           -b ${CMAKE_CURRENT_SOURCE_DIR}/data/baselines/${GLVIS_BASELINE_SYS}
           -a "-lw 1 -mslw 1 -nohidpi")

  add_custom_target(_rebaseline_stream_${test_name}
      COMMAND ${CMAKE_COMMAND} -E make_directory
        ${CMAKE_CURRENT_SOURCE_DIR}/data/baselines/local
      COMMAND ${CMAKE_COMMAND} -E copy
        ${CMAKE_CURRENT_BINARY_DIR}/test.${test_name}.saved.png
        ${CMAKE_CURRENT_SOURCE_DIR}/data/baselines/local
      DEPENDS
        ${CMAKE_CURRENT_BINARY_DIR}/test.${test_name}.saved.png
      VERBATIM)

  add_dependencies(rebaseline _rebaseline_stream_${test_name})

endforeach()

endif(NOT EMSCRIPTEN)

=== debian/changelog ===
glvis (4.3-3) unstable; urgency=medium

  * d/rules: fix $(DEBARCH).
  * d/control: add missing build-depends: xxd, libopengl-dev, libglx-dev,
    libgl-dev, libsdl2-dev, libglew-dev, libglm-dev, libfreetype-dev,
    libfontconfig-dev.

 -- Alex Myczko <tar@debian.org>  Thu, 27 Feb 2025 12:30:28 +0000

glvis (4.3-2) unstable; urgency=medium

  * d/control: add libmfem-dev to build-depends. (Closes: #1085056)

 -- Alex Myczko <tar@debian.org>  Wed, 16 Oct 2024 20:37:07 +0000

glvis (4.3-1) unstable; urgency=medium

  * Initial release. (Closes: #1034901)

 -- Alex Myczko <tar@debian.org>  Fri, 13 Sep 2024 07:55:27 +0000

=== debian/control ===
Source: glvis
Section: science
Priority: optional
Maintainer: Alex Myczko <tar@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libgl2ps-dev,
 libmfem-dev,
 libopengl-dev,
 libglx-dev,
 libgl-dev,
 libsdl2-dev,
 libglew-dev,
 libglm-dev,
 libfreetype-dev,
 libfontconfig-dev,
 patchelf,
 xxd,
Standards-Version: 4.7.0
Homepage: https://github.com/GLVis/glvis
Vcs-Browser: https://salsa.debian.org/debian/glvis
Vcs-Git: https://salsa.debian.org/debian/glvis.git

Package: glvis
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: accurate and flexible finite element visualization
 This is an OpenGL tool for visualization of finite element meshes and
 functions.

=== debian/watch ===
version=4

# GitHub hosted projects.
#opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
#    https://github.com/<user>/<project>/tags \
#    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@

## glvis 4.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -345,6 +345,14 @@
     install(CODE [[
       include (BundleUtilities)
       fixup_bundle("${CMAKE_INSTALL_PREFIX}/GLVis.app" "" "")
+      file(GLOB LIBS_TO_SIGN
+          "${CMAKE_INSTALL_PREFIX}/GLVis.app/Contents/Frameworks/*.dylib")
+      foreach(LIB ${LIBS_TO_SIGN})
+        if (NOT IS_SYMLINK ${LIB})
+          execute_process(COMMAND codesign --force --sign - ${LIB})
+        endif()
+      endforeach()
+      execute_process(COMMAND codesign --force --sign - ${CMAKE_INSTALL_PREFIX}/GLVis.app)
     ]] COMPONENT RUNTIME)
   endif(APPLE)

=== share/CMakeLists.txt ===
# Copyright (c) 2010-2024, Lawrence Livermore National Security, LLC. Produced
# at the Lawrence Livermore National Laboratory. All Rights reserved. See files
# LICENSE and NOTICE for details. LLNL-CODE-443271.
#
# This file is part of the GLVis visualization tool and library. For more
# information and source code availability see https://glvis.org.
#
# GLVis is free software; you can redistribute it and/or modify it under the
# terms of the BSD-3 license. We welcome feedback and contributions, see file
# CONTRIBUTING.md for details.

if(NOT WIN32)

add_custom_command(
    OUTPUT logo.rgba.bin.cpp
    COMMAND ${CMAKE_COMMAND} -E copy
            ${CMAKE_CURRENT_SOURCE_DIR}/logo.rgba
            ${CMAKE_CURRENT_BINARY_DIR}/logo.rgba
    COMMAND xxd -i logo.rgba > logo.rgba.bin.cpp
    DEPENDS logo.rgba
    COMMENT "Generating logo.rgba.bin.o")

add_library(glvis_logo STATIC
    ${CMAKE_CURRENT_BINARY_DIR}/logo.rgba.bin.cpp)

else()

set(GLVIS_ICON_FILE_LOCATION ${CMAKE_CURRENT_SOURCE_DIR}/logo.ico)
configure_file(resource.rc.in resource.rc)

endif(NOT WIN32)

=== debian/changelog ===
glvis (4.3.2-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Tue, 04 Mar 2025 08:38:52 +0000

## glvis 4.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2010-2024, Lawrence Livermore National Security, LLC. Produced
+# Copyright (c) 2010-2025, Lawrence Livermore National Security, LLC. Produced
 # at the Lawrence Livermore National Laboratory. All Rights reserved. See files
 # LICENSE and NOTICE for details. LLNL-CODE-443271.
 #
@@ -167,6 +167,8 @@
   list(APPEND CMAKE_PREFIX_PATH "../glew")
   find_package(GLEW REQUIRED)
   list(APPEND _glvis_libraries GLEW::GLEW)
+  # See https://github.com/nigels-com/glew/issues/192
+  list(APPEND _glvis_compile_defs "GLEW_NO_GLU")
 
   # Find 'glm' which is not part of the CMake standard modules
   list(APPEND GLM_DIR "../glm")
@@ -358,7 +360,3 @@
 
 endif(NOT EMSCRIPTEN)
 
-if(ENABLE_TESTS)
-  enable_testing()
-  add_subdirectory(tests)
-endif(ENABLE_TESTS)

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2010-2024, Lawrence Livermore National Security, LLC. Produced
+# Copyright (c) 2010-2025, Lawrence Livermore National Security, LLC. Produced
 # at the Lawrence Livermore National Laboratory. All Rights reserved. See files
 # LICENSE and NOTICE for details. LLNL-CODE-443271.
 #
@@ -15,11 +15,15 @@
   gl/shader.cpp
   gl/types.cpp
   aux_vis.cpp
+  coll_reader.cpp
+  data_state.cpp
+  file_reader.cpp
   font.cpp
   gltf.cpp
   material.cpp
   openglvis.cpp
   palettes.cpp
+  palettes_base.cpp
   sdl.cpp
   sdl_helper.cpp
   sdl_main.cpp
@@ -38,6 +42,9 @@
   gl/shader.hpp
   gl/types.hpp
   aux_vis.hpp
+  coll_reader.hpp
+  data_state.hpp
+  file_reader.hpp
   font.hpp
   geom_utils.hpp
   gltf.hpp
@@ -45,6 +52,7 @@
   material.hpp
   openglvis.hpp
   palettes.hpp
+  palettes_base.hpp
   sdl.hpp
   sdl_helper.hpp
   sdl_main.hpp

=== share/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2010-2024, Lawrence Livermore National Security, LLC. Produced
+# Copyright (c) 2010-2025, Lawrence Livermore National Security, LLC. Produced
 # at the Lawrence Livermore National Laboratory. All Rights reserved. See files
 # LICENSE and NOTICE for details. LLNL-CODE-443271.
 #

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2010-2024, Lawrence Livermore National Security, LLC. Produced
+# Copyright (c) 2010-2025, Lawrence Livermore National Security, LLC. Produced
 # at the Lawrence Livermore National Laboratory. All Rights reserved. See files
 # LICENSE and NOTICE for details. LLNL-CODE-443271.
 #
@@ -40,6 +40,7 @@
     "mobius-strip"
     "navier"
     "quad"
+    "quadrature-1D"
     "quadrature-lor"
     "remhos"
     "shaper"
@@ -61,10 +62,10 @@
       COMMAND ${CMAKE_COMMAND} -E make_directory
         ${CMAKE_CURRENT_SOURCE_DIR}/data/baselines/local
       COMMAND ${CMAKE_COMMAND} -E copy
-        ${CMAKE_CURRENT_BINARY_DIR}/test.${test_name}.saved.png
+        ${CMAKE_CURRENT_BINARY_DIR}/test.${test_name}.png
         ${CMAKE_CURRENT_SOURCE_DIR}/data/baselines/local
       DEPENDS
-        ${CMAKE_CURRENT_BINARY_DIR}/test.${test_name}.saved.png
+        ${CMAKE_CURRENT_BINARY_DIR}/test.${test_name}.png
       VERBATIM)
 
   add_dependencies(rebaseline _rebaseline_stream_${test_name})

=== tests/requirements.txt ===
scikit-image
plotly
numpy >= 1.20.0, < 2.0.0

=== debian/changelog ===
glvis (4.4-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version to 4.7.2.
  * d/copyright: bump years.

 -- Alex Myczko <tar@debian.org>  Fri, 05 Sep 2025 16:05:00 -0500

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
  libfontconfig-dev,
  patchelf,
  xxd,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/GLVis/glvis
 Vcs-Browser: https://salsa.debian.org/debian/glvis
 Vcs-Git: https://salsa.debian.org/debian/glvis.git

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

DEBARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DMFEM_DIR=/usr/include/mfem \
	    -Dmfem_DIR=/usr/lib/$(DEBARCH)/cmake/mfem \
	    -DCMAKE_INSTALL_RPATH_USE_LINK_PATH=OFF \
	    -DCMAKE_INSTALL_RPATH="" \
#	    -Dmfem_DIR=/usr/lib/cmake/mfem
#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

override_dh_auto_install:
	@echo broken

override_dh_fixperms:
	dh_fixperms
	patchelf --remove-rpath debian/glvis/usr/bin/glvis

override_dh_dwz:
	@echo broken

## glvis 4.4+git20251225+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 # introduced.
 cmake_minimum_required(VERSION 3.10)
 
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)

=== debian/changelog ===
glvis (4.4+git20251225+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Alex Myczko <tar@debian.org>  Fri, 26 Dec 2025 14:04:37 +0000

glvis (4.4+git20251225+ds-1) experimental; urgency=medium

  * New upstream version. (Closes: #1123608)

 -- Alex Myczko <tar@debian.org>  Thu, 25 Dec 2025 14:31:01 +0000

glvis (4.4-2) unstable; urgency=medium

  * d/watch: defined and updated to version 5.

 -- Alex Myczko <tar@debian.org>  Tue, 16 Dec 2025 18:18:04 +0000

=== debian/rules ===
--- 
+++ 
@@ -14,6 +14,7 @@
 
 %:
 	dh $@ --buildsystem=cmake
+# --no-parallel
 
 override_dh_auto_configure:
 	dh_auto_configure -- \

## glvis 4.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2010-2025, Lawrence Livermore National Security, LLC. Produced
+# Copyright (c) 2010-2026, Lawrence Livermore National Security, LLC. Produced
 # at the Lawrence Livermore National Laboratory. All Rights reserved. See files
 # LICENSE and NOTICE for details. LLNL-CODE-443271.
 #
@@ -23,6 +23,16 @@
 endif ("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
 
 project(glvis NONE)
+
+# Load user settings
+set(USER_CONFIG "${CMAKE_CURRENT_SOURCE_DIR}/user.cmake" CACHE PATH
+  "User configuration file. This file is not part of the GLVis source code and
+   is not distributed with GLVis. It can be used to set user-specific options,
+   such as paths to external libraries, compiler flags, etc.")
+include("${USER_CONFIG}" OPTIONAL RESULT_VARIABLE USER_CONFIG_LOADED)
+if (USER_CONFIG_LOADED)
+  message(STATUS "USER_CONFIG = ${USER_CONFIG} (LOADED)")
+endif()
 
 # Import MFEM. The following variables can be used to help CMake find MFEM:
 #  * MFEM_DIR - absolute path to the MFEM build or install prefix.
@@ -57,6 +67,14 @@
 option(GLVIS_USE_LIBPNG
   "Use libpng for taking screenshots internally"
   ON)
+
+option(GLVIS_USE_EGL
+  "Use EGL for headless rendering"
+  OFF)
+
+option(GLVIS_USE_CGL
+  "Use CGL for headless rendering"
+  APPLE)
 
 #
 # Handle a few other definitions
@@ -227,6 +245,23 @@
     message(FATAL_ERROR "Fontconfig not found.")
   endif (FONTCONFIG_LIBRARY)
 
+  # Find EGL
+  if (GLVIS_USE_EGL)
+    find_package(OpenGL OPTIONAL_COMPONENTS EGL)
+    if (OpenGL_EGL_FOUND)
+      list(APPEND _glvis_compile_defs "GLVIS_USE_EGL")
+      list(APPEND _glvis_libraries OpenGL::EGL)
+    else()
+      message(WARNING "EGL library not found. EGL disabled.")
+      set(GLVIS_USE_EGL OFF)
+    endif (OpenGL_EGL_FOUND)
+  endif (GLVIS_USE_EGL)
+
+  # Find CGL
+  if (GLVIS_USE_CGL AND NOT EMSCRIPTEN)
+    list(APPEND _glvis_compile_defs "GLVIS_USE_CGL")
+  endif (GLVIS_USE_CGL AND NOT EMSCRIPTEN)
+
   # Find threading library
   find_package(Threads REQUIRED)
   list(APPEND _glvis_libraries "${CMAKE_THREAD_LIBS_INIT}")
@@ -327,36 +362,3 @@
   if (APPLE)
     set(GLVIS_APP_ICON ${CMAKE_CURRENT_SOURCE_DIR}/share/GLVis.icns)
     set(GLVIS_APP_CREDITS ${CMAKE_CURRENT_SOURCE_DIR}/share/Credits.rtf)
-    set_source_files_properties(
-      ${GLVIS_APP_ICON} ${GLVIS_APP_CREDITS}
-      PROPERTIES
-        MACOSX_PACKAGE_LOCATION "Resources")
-
-    add_executable(app MACOSX_BUNDLE glvis.cpp
-      ${GLVIS_APP_ICON} ${GLVIS_APP_CREDITS})
-    set_target_properties(app
-      PROPERTIES
-        EXCLUDE_FROM_ALL TRUE
-        OUTPUT_NAME GLVis
-        MACOSX_BUNDLE_INFO_PLIST
-          ${CMAKE_CURRENT_SOURCE_DIR}/share/Info.cmake.plist.in)
-    target_link_libraries(app PRIVATE glvis glvis_logo)
-    install(TARGETS app
-      RUNTIME DESTINATION .
-      BUNDLE DESTINATION .)
-    install(CODE [[
-      include (BundleUtilities)
-      fixup_bundle("${CMAKE_INSTALL_PREFIX}/GLVis.app" "" "")
-      file(GLOB LIBS_TO_SIGN
-          "${CMAKE_INSTALL_PREFIX}/GLVis.app/Contents/Frameworks/*.dylib")
-      foreach(LIB ${LIBS_TO_SIGN})
-        if (NOT IS_SYMLINK ${LIB})
-          execute_process(COMMAND codesign --force --sign - ${LIB})
-        endif()
-      endforeach()
-      execute_process(COMMAND codesign --force --sign - ${CMAKE_INSTALL_PREFIX}/GLVis.app)
-    ]] COMPONENT RUNTIME)
-  endif(APPLE)
-
-endif(NOT EMSCRIPTEN)
-

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2010-2025, Lawrence Livermore National Security, LLC. Produced
+# Copyright (c) 2010-2026, Lawrence Livermore National Security, LLC. Produced
 # at the Lawrence Livermore National Laboratory. All Rights reserved. See files
 # LICENSE and NOTICE for details. LLNL-CODE-443271.
 #
@@ -10,37 +10,49 @@
 # CONTRIBUTING.md for details.
 
 list(APPEND SOURCES
+  egl/egl.cpp
+  egl/egl_main.cpp
   gl/renderer.cpp
   gl/renderer_core.cpp
   gl/shader.cpp
   gl/types.cpp
+  sdl/sdl.cpp
+  sdl/sdl_helper.cpp
+  sdl/sdl_main.cpp
   aux_vis.cpp
   coll_reader.cpp
   data_state.cpp
   file_reader.cpp
   font.cpp
   gltf.cpp
+  glwindow.cpp
   material.cpp
   openglvis.cpp
   palettes.cpp
+  palettes_default.cpp
   palettes_base.cpp
-  sdl.cpp
-  sdl_helper.cpp
-  sdl_main.cpp
+  script_controller.cpp
   stream_reader.cpp
   vsdata.cpp
   vssolution.cpp
   vssolution3d.cpp
   vsvector.cpp
-  vsvector3d.cpp)
+  vsvector3d.cpp
+  window.cpp)
 
 list(APPEND HEADERS
+  egl/egl.hpp
+  egl/egl_main.hpp
   gl/attr_traits.hpp
   gl/platform_gl.hpp
   gl/renderer.hpp
   gl/renderer_core.hpp
   gl/shader.hpp
   gl/types.hpp
+  sdl/sdl.hpp
+  sdl/sdl_helper.hpp
+  sdl/sdl_main.hpp
+  sdl/sdl_mac.hpp
   aux_vis.hpp
   coll_reader.hpp
   data_state.hpp
@@ -48,22 +60,21 @@
   font.hpp
   geom_utils.hpp
   gltf.hpp
+  glwindow.hpp
   logo.hpp
   material.hpp
   openglvis.hpp
   palettes.hpp
   palettes_base.hpp
-  sdl.hpp
-  sdl_helper.hpp
-  sdl_main.hpp
-  sdl_mac.hpp
+  script_controller.hpp
   stream_reader.hpp
   visual.hpp
   vsdata.hpp
   vssolution.hpp
   vssolution3d.hpp
   vsvector.hpp
-  vsvector3d.hpp)
+  vsvector3d.hpp
+  window.hpp)
 
 if(EMSCRIPTEN)
   # Emscripten build target
@@ -84,15 +95,15 @@
   target_link_libraries(libglvis PUBLIC "${_glvis_libraries}")
 else()
   # Desktop build target
-  list(APPEND SOURCES gl/renderer_ff.cpp threads.cpp gl2ps.c sdl_x11.cpp)
-  list(APPEND HEADERS gl/renderer_ff.hpp threads.hpp gl2ps.h sdl_x11.hpp)
+  list(APPEND SOURCES gl/renderer_ff.cpp threads.cpp gl2ps.c sdl/sdl_x11.cpp)
+  list(APPEND HEADERS gl/renderer_ff.hpp threads.hpp gl2ps.h sdl/sdl_x11.hpp)
   if (APPLE)
-    list(APPEND SOURCES sdl_mac.mm)
-    list(APPEND HEADERS sdl_mac.hpp)
+    list(APPEND SOURCES sdl/sdl_mac.mm)
+    list(APPEND HEADERS sdl/sdl_mac.hpp)
   endif()
   if (WIN32)
-    list(APPEND SOURCES sdl_windows.cpp)
-    list(APPEND HEADERS sdl_windows.hpp)
+    list(APPEND SOURCES sdl/sdl_windows.cpp)
+    list(APPEND HEADERS sdl/sdl_windows.hpp)
   endif()
   add_library(glvis ${SOURCES} ${HEADERS})
   target_compile_definitions(glvis PUBLIC "${_glvis_compile_defs}")

=== share/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2010-2025, Lawrence Livermore National Security, LLC. Produced
+# Copyright (c) 2010-2026, Lawrence Livermore National Security, LLC. Produced
 # at the Lawrence Livermore National Laboratory. All Rights reserved. See files
 # LICENSE and NOTICE for details. LLNL-CODE-443271.
 #

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2010-2025, Lawrence Livermore National Security, LLC. Produced
+# Copyright (c) 2010-2026, Lawrence Livermore National Security, LLC. Produced
 # at the Lawrence Livermore National Laboratory. All Rights reserved. See files
 # LICENSE and NOTICE for details. LLNL-CODE-443271.
 #
@@ -31,7 +31,10 @@
     "ex27"
     "ex3"
     "ex5"
+    "ex6-dofs-numbering"
     "ex9"
+    "ex22-scalar"
+    "ex22-vector"
     "klein-bottle"
     "laghos"
     "mesh-explorer"

=== debian/changelog ===
glvis (4.5-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: bump years.

 -- Alex Myczko <tar@debian.org>  Sun, 08 Feb 2026 10:28:54 +0100

=== debian/watch ===
Version: 5

# GitHub hosted projects.
Template: Github
Owner: GLVis
Project: glvis
